<template>
  <v-card>
    <v-card-title>Банковские реквизиты</v-card-title>
    <v-card-text>
      <container>
        <v-row>
          <v-col cols='12'>
            <v-chip-group>
              <offer-status :status='offer.status'/>
              <offer-type :type='offer.type'/>
            </v-chip-group>
          </v-col>
          <v-col cols='12'>
            <v-text-field
              label='LDS'
              readonly
              :value='offer.amount | fromScaledAmount'
              hide-details
            />
          </v-col>
          <v-col cols='12'>
            <v-text-field
              :label='`Стоимость ${offer.rate.currency}`'
              readonly
              :value='offer.rate.price | fromScaledPrice'
              hide-details
            />
          </v-col>
          <v-col cols='12'>
            <v-text-field
              :label='`Цена ${offer.rate.currency} за LDS`'
              readonly
              :value='(offer.rate.price / (offer.amount / 10 ** 18 )) | fromScaledPrice'
              hide-details
            />
          </v-col>
          <v-col cols='12'>
            <v-text-field
              label='Дата создания'
              readonly
              :value='createdAt'
              hide-details
            />
          </v-col>
          <v-col cols='12'>
            <v-text-field
              label='Адрес владельца'
              readonly
              :value='offer.owner.address'
              hide-details
            />
          </v-col>
          <template v-if='isReserved'>
            <v-col cols='12'>
              <v-text-field
                label='Адрес резервирования'
                readonly
                :value='offer.reservedBy.address'
                hide-details
              />
            </v-col>
            <v-col cols='12'>
              <v-text-field
                label='Дата резервирования'
                readonly
                :value='offer.reservedAt | localDateString'
                hide-details
              />
            </v-col>
          </template>
        </v-row>
        <v-row>
          <v-col cols='12'>
            <v-btn block color='primary' v-if='canBeConfirmPayment' @click='confirmPayment'>Подтвердить выплату</v-btn>
          </v-col>
          <v-col cols='12'>
            <offer-close-modal v-if='closeOfferData' :offer.sync='closeOfferData'/>
            <v-btn block color='red darken-3' @click='closeOffer' v-if='canBeClose'>Закрыть</v-btn>
          </v-col>
        </v-row>
      </container>
    </v-card-text>
  </v-card>
</template>

<script lang='ts'>

import Vue from 'vue';
import Component from 'vue-class-component';
import { ConfirmOfferCommand, OfferResponse, PayOfferCommand } from '@/api/ledius-token';
import { Prop } from 'vue-property-decorator';
import { OfferStatusEnum, OfferTypeEnum } from '@/api/patch/ledius-token.enums';
import OfferType from './OfferType.vue';
import OfferStatus from '@/components/offers/OfferStatus.vue';
import { AuthInfoResponse } from '@/api/courses';
import OfferCloseModal from '@/components/offers/OfferCloseModal.vue';

@Component({
  components: {
    OfferStatus,
    OfferType,
    OfferCloseModal
  }
})
export default class OfferInfoCard extends Vue {
  @Prop({
    required: true,
    type: Object
  })
  private readonly offer!: OfferResponse;

  private closeOfferData: OfferResponse | null = null;

  private get createdAt(): string {
    const date = new Date(this.offer.createdAt);
    return `${date.toLocaleString()}`;
  }

  private get isReserved(): boolean {
    return this.offer.status as never === OfferStatusEnum.RESERVED;
  }

  private get isOpened(): boolean {
    return this.offer.status as never === OfferStatusEnum.OPENED;
  }

  private get isSell(): boolean {
    return this.offer.type as never === OfferTypeEnum.SELL;
  }

  private get isBuy(): boolean {
    return this.offer.type as never === OfferTypeEnum.SELL;
  }

  private get canBeClose(): boolean {
    return this.isOpened || (this.isReserved && this.isSell);
  }

  private get canBeConfirmPayment(): boolean {
    return this.isReserved && this.isBuy;
  }

  private get authInfo(): AuthInfoResponse {
    return this.$store.getters['auth/info'];
  }

  private async confirmPayment(): Promise<void> {
    await this.$store.dispatch('exchange/offers/confirmPayment', {
      id: this.offer.id,
      userId: this.authInfo.id
    } as ConfirmOfferCommand);
  }

  private closeOffer(): void {
    this.closeOfferData = this.offer;
  }
}

</script>

<style scoped>

</style>
